package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class ERRORHandler extends MessageHandler {
	public ERRORHandler(Protocol p)
	{
		super(p, 1, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		TheXBot.shutdown();
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}

