package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class GHandler extends MessageHandler {
	public GHandler(Protocol p)
	{
		super(p, 1, SourceType.ANY);
	}
	
	@Override
	public void handle(User u, Message m)
	{
		this.protocol.pong(u);
	}

	@Override
	public void handle(Server s, Message m)
	{
		this.protocol.pong(s);
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}

