/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Channel;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class JHandler extends MessageHandler {
	public JHandler(Protocol p)
	{
		super(p, 2, SourceType.USER);
	}

	@Override
	public void handle(User u, Message m)
	{
		// ABAAE J #x[,#moo] 123567809
		if (m.args[0].equals("0")) {
			for (final Channel c : u.getChannels()) {
				c.removeUser(u);
				if (c.getUsers().isEmpty() && !c.isPersistent()) {
					TheXBot.em().removeChannel(c);
				}
			}
			u.partAll();
			return;
		}

		for (final String name : m.args[0].split(",")) {
			Channel c = TheXBot.em().findChannel(name);

			if (c == null) {
				c = new Channel(name, Integer.parseInt(m.args[1]));
				TheXBot.em().addChannel(c);
			}

			c.addUser(u);
			u.join(c);
		}
	}

	@Override
	public void handle(Server s, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
