package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.TheXBot;
import invalid.thexbot.Util;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class SNHandler extends MessageHandler {
	public SNHandler(Protocol p)
	{
		super(p, 2, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		User u = TheXBot.em().findUser(m.args[0]);
		if (u == null || u.getNick().equals(m.args[1])) {
			return;
		}

		u.setNick(m.args[1]);
		u.setNickTS(Util.getTimestamp());
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
