package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class MKHandler extends MessageHandler {
	public MKHandler(Protocol p)
	{
		super(p, 3, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		User u = TheXBot.em().findUser(m.args[0]);
		if (u == null)
			return;
		
		if (m.args[1].equals("CERTFP"))
			u.setMetaData("certfp", m.args[2]);
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}

